package cc.toph.tutorialmod.item.custom;

import java.util.ArrayList;

import net.minecraft.core.BlockPos;
import net.minecraft.network.chat.Component;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;

public class MetalDetectorItem extends Item {

	public MetalDetectorItem(Properties pProperties) {
		super(pProperties);
		// TODO Auto-generated constructor stub
	}

	@Override
	public InteractionResult useOn(UseOnContext pContext) {

		if (!pContext.getLevel().isClientSide()) {
			BlockPos positionClicked = pContext.getClickedPos();
			Player player = pContext.getPlayer();
			var foundBlock = false;

			for (int i = 0; i <= positionClicked.getY() + 64; i++) {
				var state = pContext.getLevel().getBlockState(positionClicked.below(i));
				if (isValuableBlock(state)) {
					notifyCords(positionClicked.below(i), player, state);
				}
			}

			if (!foundBlock) {
				player.sendSystemMessage(Component.literal("Loser Loser"));
			}
		}

		pContext.getItemInHand().hurtAndBreak(1, pContext.getPlayer(),
				(player) -> player.broadcastBreakEvent(player.getUsedItemHand()));

		return InteractionResult.SUCCESS;
	}

	private boolean isValuableBlock(BlockState state) {

		final var valuables = new ArrayList<Block>();

		valuables.add(Blocks.COAL_ORE);
		valuables.add(Blocks.IRON_ORE);
		valuables.add(Blocks.GOLD_ORE);
		valuables.add(Blocks.DIAMOND_ORE);
		valuables.add(Blocks.LAPIS_ORE);
		valuables.add(Blocks.REDSTONE_ORE);
		valuables.add(Blocks.EMERALD_ORE);

		return valuables.contains(state.getBlock());
	}

	private void notifyCords(BlockPos below, Player player, BlockState state) {
		var messg = Component.literal("Found " + state.getBlock().getName().getString() + " at " + below.getX() + " "
				+ below.getY() + " " + below.getZ());
		player.sendSystemMessage(messg);
	}
}
